# TODO:
#  - package for ruby API
#  - subpackage for driver backend deps if code patched to support it:
#    sphinx-0.9.9-2.i686: required "libodbc.so.1" is provided by following packages:
#    libmysqlclient.so.16 libmysqlclient.so.16(libmysqlclient_16) libpq.so.5
#
# Conditional build:
%bcond_without	java		# without Java support
%bcond_without	libstemmer	# without libstemmer support
%bcond_without	mysql		# without MySQL support
%bcond_without	pgsql		# without PostgreSQL support

%undefine	with_java

%{?with_java:%include	/usr/lib/rpm/macros.java}
%include	/usr/lib/rpm/macros.php
%define		php_min_version 5.0.4
Summary:	Free open-source SQL full-text search engine
Summary(pl.UTF-8):	Silnik przeszukiwania pełnotekstowego SQL open-source
Name:		sphinx
Version:	0.9.9
Release:	8
License:	GPL v2
Group:		Applications/Databases
Source0:	http://www.sphinxsearch.com/downloads/%{name}-%{version}.tar.gz
# Source0-md5:	7b9b618cb9b378f949bb1b91ddcc4f54
Source1:	%{name}.init
Source2:	%{name}.logrotate
Source3:	%{name}.conf.sh
Patch0:		%{name}-system-libstemmer.patch
Patch1:		bug-468.patch
Patch2:		bug-297.patch
URL:		http://www.sphinxsearch.com/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	expat-devel
%{?with_java:BuildRequires:	jdk}
BuildRequires:	libstdc++-devel
%{?with_libstemmer:BuildRequires:	libstemmer-devel}
BuildRequires:	libtool
%{?with_mysql:BuildRequires:	mysql-devel}
%{?with_pgsql:BuildRequires:	postgresql-devel}
BuildRequires:	python
BuildRequires:	python-modules
BuildRequires:	rpm-javaprov
BuildRequires:	rpm-php-pearprov >= 4.4.2-11
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.461
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Provides:	group(sphinx)
Provides:	user(sphinx)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/%{name}

%description
Sphinx is a a standalone search engine, meant to provide fast,
size-efficient and relevant fulltext search functions to other
applications. Sphinx was specially designed to integrate well with SQL
databases and scripting languages. Currently built-in data sources
support fetching data either via direct connection to MySQL, or from
an XML pipe.

%description -l pl.UTF-8
Sphinx jest samodzielnym silnikiem przeszukującym, dostarczającym
innym aplikacjom szybkie, zoptymalizowane rozmiarowo funkcje
przeszukiwania pełnotekstowego. Sphinx został specjalnie
zaprojektowany z myślą o dobrej integracji z bazami danych SQL oraz
językami skryptowymi. Obecnie wbudowane źródła danych wspierają
pobieranie danych poprzez bezpośrednie połączenie z MySQL lub z potoku
XML.

%package -n libsphinxclient
Summary:	Client library for Sphinx
Summary(pl.UTF-8):	Biblioteka kliencka do Sphinx
Group:		Libraries

%description -n libsphinxclient
This package provides a client library for Sphinx search engine.

%description -n libsphinxclient -l pl.UTF-8
Ten pakiet dostarcza bibliotekę kliencką do silnika Sphinx.

%package -n libsphinxclient-devel
Summary:	Header files for sphinxclient library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki sphinxclient
Group:		Development/Libraries
Requires:	libsphinxclient = %{version}-%{release}

%description -n libsphinxclient-devel
Header files for sphinxclient library.

%description -n libsphinxclient-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki sphinxclient.

%package -n libsphinxclient-static
Summary:	Static sphinxclient library
Summary(pl.UTF-8):	Statyczna biblioteka sphinxclient
Group:		Development/Libraries
Requires:	libsphinxclient-devel = %{version}-%{release}

%description -n libsphinxclient-static
Static sphinxclient library.

%description -n libsphinxclient-static -l pl.UTF-8
Statyczna biblioteka sphinxclient.

%package -n java-sphinx
Summary:	Java API for Sphinx
Summary(pl.UTF-8):	API Javy dla Sphinksa
Group:		Development/Languages/Java
Requires:	jpackage-utils

%description -n java-sphinx
Java API for Sphinx.

%description -n java-sphinx -l pl.UTF-8
API Javy dla Sphinksa.

%package -n php-sphinx
Summary:	PHP API for Sphinx
Summary(pl.UTF-8):	API PHP dla Sphinksa
Group:		Libraries
Requires:	php-common >= 4:%{php_min_version}
Provides:	php(sphinx)

%description -n php-sphinx
PHP API for Sphinx.

%description -n php-sphinx -l pl.UTF-8
API PHP dla Sphinksa.

%package -n python-sphinx
Summary:	Python API for Sphinx
Summary(pl.UTF-8):	API Python dla Sphinksa
Group:		Development/Languages/Python
%pyrequires_eq	python

%description -n python-sphinx
Python API for Sphinx.

%description -n python-sphinx -l pl.UTF-8
API Pythona dla Sphinksa.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

sed -i -e '
	s#/var/run/#/var/run/sphinx/#
	s#@CONFDIR@/log/searchd.pid#/var/run/sphinx/searchd.pid#
	s#@CONFDIR@/log/#/var/log/sphinx/#g
	s#@CONFDIR@/data/#/var/lib/sphinx/#g
' sphinx*.conf.in

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
CPPFLAGS=-D_FILE_OFFSET_BITS=64
%configure \
	--with%{!?with_libstemmer:out}-libstemmer \
	--with%{!?with_pgsql:out}-pgsql \
	--with%{!?with_mysql:out}-mysql
%{__make} -j1
# use .conf ext for %doc
cp -f sphinx.conf.dist sphinx.conf
cp -f sphinx-min.conf.dist sphinx-min.conf

# libsphinxclient
cd api/libsphinxclient
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
CPPFLAGS=-D_FILE_OFFSET_BITS=64
%configure
%{__make} -j1
cd ../..

# java api
%if %{with java}
export JAVA_HOME="%{java_home}"
%{__make} -j1 -C api/java
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},/etc/{logrotate.d,rc.d/init.d},/var/{log,run,lib}/%{name},/var/log/archive/%{name}}

%{__make} -j1 install \
	DESTDIR=$RPM_BUILD_ROOT

rm $RPM_BUILD_ROOT%{_sysconfdir}/example.sql
rm $RPM_BUILD_ROOT%{_sysconfdir}/sphinx.conf.dist

# create default config with no index definition
sed -e '/## data source definition/,/## indexer settings/d' sphinx.conf > $RPM_BUILD_ROOT%{_sysconfdir}/sphinx-common.conf
# dir for indexes definition
install -d $RPM_BUILD_ROOT%{_sysconfdir}/index.d

rm $RPM_BUILD_ROOT%{_sysconfdir}/sphinx-min.conf.dist
mv $RPM_BUILD_ROOT{%{_bindir},%{_sbindir}}/searchd
install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}
install -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.conf

install -d $RPM_BUILD_ROOT%{php_data_dir}
cp -p api/sphinxapi.php $RPM_BUILD_ROOT%{php_data_dir}

# libsphinxclient
%{__make} -C api/libsphinxclient install \
	DESTDIR=$RPM_BUILD_ROOT

# python api
install -d $RPM_BUILD_ROOT%{py_sitescriptdir}
cp -p api/sphinxapi.py $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_comp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_postclean

# ruby api

# java api
%if %{with java}
install -d $RPM_BUILD_ROOT%{_javadir}
cp -p api/java/sphinxapi.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n libsphinxclient -p /sbin/ldconfig
%postun	-n libsphinxclient -p /sbin/ldconfig

%pre
%groupadd -g 249 sphinx
%useradd -u 249 -d /var/lib/%{name} -g sphinx -c "Sphinx Search" sphinx

%post
/sbin/chkconfig --add sphinx
%service sphinx restart

%preun
if [ "$1" = 0 ]; then
	%service sphinx stop
	/sbin/chkconfig --del sphinx
fi

%triggerpostun -- %{name} < 0.9.9-7.6
if [ -f %{_sysconfdir}/sphinx.conf.rpmsave ]; then
	cp -f %{_sysconfdir}/sphinx-common.conf{,.rpmnew}
	mv -f %{_sysconfdir}/sphinx.conf.rpmsave %{_sysconfdir}/sphinx-common.conf
	%service -q sphinx restart
fi

%files
%defattr(644,root,root,755)
%doc doc/sphinx.txt example.sql sphinx.conf sphinx-min.conf

%dir %attr(750,root,sphinx) %{_sysconfdir}
# main sphinx config
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,sphinx) %{_sysconfdir}/sphinx-common.conf
# shell wrapper which loads main config and extra indexes config
%attr(755,root,sphinx) %{_sysconfdir}/sphinx.conf
# put here *.conf files defining extra indexes
%dir %attr(750,root,sphinx) %{_sysconfdir}/index.d

%config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/%{name}
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(755,root,root) %{_bindir}/indexer
%attr(755,root,root) %{_bindir}/indextool
%attr(755,root,root) %{_bindir}/search
%attr(755,root,root) %{_bindir}/spelldump
%attr(755,root,root) %{_sbindir}/searchd

%dir %attr(771,root,sphinx) /var/run/sphinx
%dir %attr(770,root,sphinx) /var/log/sphinx
%dir %attr(770,root,sphinx) /var/log/archive/sphinx
%dir %attr(770,root,sphinx) /var/lib/sphinx

%files -n libsphinxclient
%defattr(644,root,root,755)
%doc api/libsphinxclient/README
%attr(755,root,root) %{_libdir}/libsphinxclient-*.*.*.so

%files -n libsphinxclient-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libsphinxclient.so
%{_libdir}/libsphinxclient.la
%{_includedir}/*.h

%files -n libsphinxclient-static
%defattr(644,root,root,755)
%{_libdir}/libsphinxclient.a

%if %{with java}
%files -n java-sphinx
%defattr(644,root,root,755)
%doc api/java/README
%{_javadir}/sphinx*.jar
%endif

%files -n php-sphinx
%defattr(644,root,root,755)
%{php_data_dir}/sphinxapi.php

%files -n python-sphinx
%defattr(644,root,root,755)
%{py_sitescriptdir}/*.py[co]
%changelog
* Tue Nov 26 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sphinx.git;a=log;h=AC-branch

* Fri Nov 25 2011 Elan Ruusamäe <glen@pld-linux.org> bd84607
- add include support from main config; trigger included, but you need to start daemon after upgrade

* Fri Nov 25 2011 Elan Ruusamäe <glen@pld-linux.org> 9b46cda
- allow override searchd config

* Thu Mar 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 71cde6e
- release 7

* Wed Feb 09 2011 Elan Ruusamäe <glen@pld-linux.org> 1657764
- 0000297: indexer --rotate causes non-recoverable lock failure occasionally

* Sat Feb 05 2011 sparky <sparky@pld-linux.org> adb1201
- corrected lang tag in %description

* Fri Jul 09 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 6f70f99
- release 5

* Wed Jun 16 2010 Elan Ruusamäe <glen@pld-linux.org> 1e790f6
- release 4

* Mon Jun 14 2010 Elan Ruusamäe <glen@pld-linux.org> 80101f7
- php-sphinx provides php(sphinx) virtual (there exists pecl ext as well)

* Mon Jun 14 2010 Elan Ruusamäe <glen@pld-linux.org> 38edad9
- php class does not use mbstring, only workarounds if mbstring.func_overload is set

* Mon Jun 14 2010 Elan Ruusamäe <glen@pld-linux.org> ad3a0b2
- release 3

* Mon Jun 14 2010 Elan Ruusamäe <glen@pld-linux.org> aa4b3fd
- secure sphinx.config, may contain passwords

* Tue Jun 01 2010 Elan Ruusamäe <glen@pld-linux.org> 84c91ba
- add reload action

* Thu May 13 2010 Elan Ruusamäe <glen@pld-linux.org> 965fad7
- release 2

* Wed May 12 2010 sparky <sparky@pld-linux.org> 4d29451
- BR: libtool, python, python-modules, rpm-pythonprov

* Sat Apr 17 2010 Jacek Konieczny <jajcus@pld-linux.org> ff8e46d
- do not pull java-sun via BR - icedtea6 should be enough in all (most) cases

* Mon Apr 12 2010 Elan Ruusamäe <glen@pld-linux.org> da5159a
- fix service stop

* Mon Apr 12 2010 Elan Ruusamäe <glen@pld-linux.org> 4b37062
- add log archive dir

* Mon Apr 12 2010 Elan Ruusamäe <glen@pld-linux.org> 89a2c40
- tabs

* Mon Apr 12 2010 Elan Ruusamäe <glen@pld-linux.org> db04d92
- add logrotate, inspired from fc

* Mon Apr 12 2010 Elan Ruusamäe <glen@pld-linux.org> 2d2e893
- add sphinx /var dirs

